#!/usr/bin/env python
# -*- coding: utf-8 -*-
from .exception import JiraApiException


class Project:

    __module__ = "jira_yak"

    def __init__(self, api, key):
        self.client = api
        self.project_key = key

    def get_project(self):
        """Get active Jira project.

        :return: JSON object representing entire Jira project, otherwise None
        """
        projects = None
        try:
            projects = self.client.projects()
        except ProjectException:
            print("[!] Failed to get Jira projects.\nRetrying in a few seconds.")
            try:
                projects = self.client.projects()
            except ProjectException:
                print("[!] Failed to get Jira projects.")
        finally:
            # projects = None # test!!!
            return next(filter(lambda proj: proj.key.upper() == self.project_key, projects), None)


class ProjectException(JiraApiException):
    pass
