#!/usr/bin/env python
# -*- coding: utf-8 -*-
from .exception import JiraApiException, JiraValidationException


class Sprint:

    __module__ = "jira_yak"

    def __init__(self, api, key):
        self.client = api
        self.project_key = key

    def get_current_sprint(self, board_id):
        """Given a board_id, get the current sprint the project is in. Also try and filter out that Moodle shit.

        :param board_id: ID for the current Jira board
        :return:
        """
        if not board_id or board_id is None:
            raise SprintValidationException("[*] Invalid board_id")
        sprints = None
        try:
            sprints = self.client.sprints(board_id)
        except SprintException:
            print("[!] Failed to get Jira sprints.\nRetrying in a few seconds.")
            try:
                sprints = self.client.sprints(board_id)
            except SprintException:
                print("[!] Failed to get Jira sprints.")
        finally:
            # boards = None # test!!!
            return next(filter(lambda story: story.state.lower() == "active" and "release sprint" in story.name.lower(), sprints), None)


class SprintException(JiraApiException):
    pass


class SprintValidationException(JiraValidationException):
    pass
